#include <exec/libraries.h>
#include <libraries/configvars.h>
#include <libraries/expansion.h>

extern void CloseLibrary();
extern struct ConfigDev *FindConfigDev();
extern struct Library *OpenLibrary();

struct Library  *ExpansionBase;

main()
{
	struct ConfigDev *cd;

	ExpansionBase = OpenLibrary(EXPANSIONNAME, 33L);

	if (ExpansionBase)
	{
	cd = 0L;

	while (cd = FindConfigDev(cd, -1L, -1L))
	{
	printf("\tcd_Flags        = %x\n",  cd->cd_Flags);
	printf("\ter_Type         = %x\n",  cd->cd_Rom.er_Type);
	printf("\ter_Product      = %x\n",  cd->cd_Rom.er_Product);
	printf("\ter_Flags        = %x\n",  cd->cd_Rom.er_Flags);
	printf("\ter_Reserved03   = %x\n",  cd->cd_Rom.er_Reserved03);
	printf("\ter_Manufacturer = %x\n",  cd->cd_Rom.er_Manufacturer);
	printf("\ter_SerialNumber = %lx\n", cd->cd_Rom.er_SerialNumber);
	printf("\ter_InitDiagVec  = %x\n",  cd->cd_Rom.er_InitDiagVec);
	printf("\ter_Reserved0c   = %x\n",  cd->cd_Rom.er_Reserved0c);
	printf("\ter_Reserved0d   = %x\n",  cd->cd_Rom.er_Reserved0d);
	printf("\ter_Reserved0e   = %x\n",  cd->cd_Rom.er_Reserved0e);
	printf("\ter_Reserved0f   = %x\n",  cd->cd_Rom.er_Reserved0f);
	printf("\tcd_BoardAddr    = %lx\n", cd->cd_BoardAddr);
	printf("\tcd_BoardSize    = %lx\n", cd->cd_BoardSize);
	printf("\tcd_SlotAddr     = %x\n",  cd->cd_SlotAddr);
	printf("\tcd_SlotSize     = %x\n",  cd->cd_SlotSize);
	printf("\tcd_Driver       = %lx\n", cd->cd_Driver);
	printf("\tcd_NextCD       = %lx\n", cd->cd_NextCD);
	printf("\tcd_Unused[0]    = %lx\n", cd->cd_Unused[0]);
	printf("\tcd_Unused[1]    = %lx\n", cd->cd_Unused[1]);
	printf("\tcd_Unused[2]    = %lx\n", cd->cd_Unused[2]);
	printf("\tcd_Unused[3]    = %lx\n", cd->cd_Unused[3]);
	printf("\n");
	}
	CloseLibrary(ExpansionBase);
	}
}
