/*     Compile a C program			*/
/*     Updated for Lattice Version 4.1		*/

parse arg fname

echo 'Compiling' fname

/* Note: -d option: turns on debug mode !!! */
/* 		-cf option: compiler insures that prototypes exist for all functions */

lc1 = 'LC:lc1 >QUAD:' || fname || '.err -b0 -cc -cf -cw -d -oQUAD: Source:' || fname
lc2 = 'LC:lc2 >QUAD:$$temp -oOBJ: -v -y QUAD:' || fname
cp1 = 'cp Source:' || fname || '.c SourceDisk:Source'
cp2 = 'cp OBJ:' || fname || '.o SourceDisk:Source/Obj'

if exists( "Source:" || fname || ".c" )
	then	address COMMAND lc1
	else	do
		echo fname || '.c does not exist!!!'
		exit 30
		end

if exists( 'QUAD:' || fname || '.q' )
	then	do
		echo 'Pass 1 on' fname 'succeeded.'
		address COMMAND lc2
		end
	else	do
		echo 'Pass 1 on' fname 'failed.'
		exit 40
		end


if ~ exists( 'OBJ:' || fname || '.o' )
   then	do
		echo 'Pass 2 on' fname 'failed.'
		exit 50
		end

echo 'Pass 2 on' fname 'succeeded.'
'delete ram:$$temp'

/* if exists( 'SourceDisk:' ) */
/*	then	do */
/*		address COMMAND cp1 */
/*		echo fname || '.c copied to SourceDisk:Source' */
/*		address COMMAND cp2 */
/*		end */

echo
exit
