.c.o:
        copy $*.c to ram:
        lc -ct -f -oram:$@ ram:$*.c
        copy ram:$@ to $@
        -delete ram:$@
        -delete ram:$*.c

ofiles = scrnio.o scrnops.o scrndef.o main.o gadgetdef.o menudef.o graypat.o mouse.o gadgetuse.o
gfiles = bezpt.o revolve.o control.o poly.o fasttrig.o
imagefiles = readilbm.o writeilbm.o packer.o mapstuff.o mapcalc.o getfilenames.o mapimgpix.o

all:    surf MergeRGB


MergeRGB:       MergeRGB.o
                Blink with MergeRGB.lnk

Surf:           $(ofiles) $(gfiles) $(imagefiles)
                blink with surf.lnk

bezpt.o:        scrnio.h control.h bezpt.h mytypes.h

control.o:      bezpt.h control.h scrnio.h mytypes.h

fasttrig.o:     fasttrig.h

getfilenames.o:  scrnio.ih scrndef.h mytypes.h

gadgetdef.o:    scrnio.ih scrndef.h gadgetdef.h mytypes.h bezpt.h poly.h revolve.h

gadgetuse.o:    scrnio.ih scrndef.h gadgetdef.h mytypes.h poly.h

main.o: scrnio.h mytypes.h

menu_files.o:   gadgetdef.h

menu_scrn.o:    scrndef.h

menudef.o:      scrnio.h menudef.h scrndef.h poly.h menu_color.c menu_scrn.c menu_image.c menu_files.c

mouse.o:        scrnio.ih scrnio.h mytypes.h bezpt.h control.h

poly.o: mytypes.h scrnio.h bezpt.h revolve.h control.h poly.h readilbm.h

readilbm.o mapimgpix.o:     readilbm.h

revolve.o:      fasttrig.h bezpt.h revolve.h mytypes.h

scrndef.o:      scrndef.h

mapcalc.o:      mytypes.h mapstuff.h

mapstuff.o:     poly.h mapstuff.h

