/* this opens a window with buttons which run macros */

   call MenuWindow(FASTHOST,FASTPORT)
   call AddMenu(FASTHOST,"Basic Commands")
   call AddItem(FASTHOST,"Quit","quit",Q)

   call AddGadget(FASTHOST,6,11,"CALC"," Calculator  ","calc")
   call AddGadget(FASTHOST,6,22,"FLIST"," FileList    ","'address command ""filelist/arexxdu""'")
   call AddGadget(FASTHOST,6,33,"PHONE"," PhoneBook   ","'address command e startup ""phonebook/startphone""'")
   call AddGadget(FASTHOST,6,44,"IBM"," Log IBM     ","'address command runwsh log logibm'")
   call AddGadget(FASTHOST,6,55,"BIX"," For Rent    ","'address command echo for_rent")
   call AddGadget(FASTHOST,6,66,"BOFA"," New CLI     ","'address command newwsh'")
   call AddGadget(FASTHOST,6,77,"DC"," DiskCopy    ","'address command diskcopy'")
   call AddGadget(FASTHOST,6,88,"FM"," Format      ","'address command format'")
   call AddGadget(FASTHOST,6,99,"PMEM"," PHYZMemo    ","'address command runwsh phyzmemo'")
   call AddGadget(FASTHOST,6,110,"PLET"," PHYZLett    ","'address command runwsh phyzlett SLAC '")
   call AddGadget(FASTHOST,6,121,"PPUB"," PHYZPub     ","'address command runwsh phyzpub'")
   call AddGadget(FASTHOST,6,132,"MLET"," MYLett      ","'address command runwsh phyzlett MY '")
   call AddGadget(FASTHOST,6,143,"LENS"," Lens        ","'address command runwsh lens'")
   call AddGadget(FASTHOST,6,154,"TXED"," Edit        ","'address command e'")
   call AddGadget(FASTHOST,6,165,"SCHED"," Reminder    ","'address command setremind'")

   call SetNotify(FASTHOST,GADGETUP,REXX)
   call SetNotify(FASTHOST,CLOSEWINDOW,FASTHOST)
   call SetNotify(FASTHOST,MENUPICK,FASTHOST)

exit

/* MenuWindow.rexx - menu making function */

MenuWindow:
arg menuhost, menuport

runwsh  "'x=createhost("menuhost||","||menuport||")'"
mp = openport(menuport)
do i = 1 to 2
  address command 'c:WaitForPort 'menuhost
  address command 'c:WaitForPort 'menuport
  xx=showlist('p',menuhost)
  yy=showlist('p',menuport)
  if xx & yy then leave i
end

idcmp = 'CLOSEWINDOW+GADGETUP+MENUPICK'
flags = 'WINDOWCLOSE+WINDOWDRAG+WINDOWDEPTH'

   call SetReqColor(menuhost,OKAY,1)
/*   call SetReqColor(menuhost,BACK,1)
*/
   call SetReqColor(menuhost,SHADOW,0)
   call SetReqColor(menuhost,BLOCK,1)
   call SetReqColor(menuhost,BOX,1)

call OpenWindow(menuhost,screencols()-120,screenrows()-186,120,185, idcmp, flags)
   call SetAPen(menuhost,1)
   call SetBPen(menuhost,1)
   call SetDrMd(menuhost,JAM2)


return 0
