/* getfile.h */


#ifndef GET_FNAMEH

#define GET_FNAMEH

#define FNAME_SIZE 33
#define MAXSTRINGSIZE 50

/* get_fname requires a few unique gadget-ids, origined at FGAD	*/
/* In the unlikely event this conflicts with any of your gadgets, */
/* change this equate to allow 16 contiguous unique ID's	*/

#define FGAD		(7000L)
#define OK_GAD		(FGAD+1)
#define CANCEL		(FGAD+2)
#define DF0_GAD		(FGAD+3)
#define DF1_GAD		(FGAD+4)
#define DH0_GAD		(FGAD+5)
#define DIR_PROP	(FGAD+6)
#define PATH		(FGAD+7)
#define FILENAME	(FGAD+8)
#define DIR_ENT1	(FGAD+9)
#define DIR_ENT2	(FGAD+10)
#define DIR_ENT3	(FGAD+11)
#define DIR_ENT4	(FGAD+12)
#define DIR_ENT5	(FGAD+13)
#define FCHARS		32L	/* Number of chars allowed in file name	*/
#define DIR_SIZ		50L	/* Number of chars in a dir name...	*/
#define MAX_STR		DIR_SIZ+2L

/* Number directory entries on screen. Simply changing this number is not
   enough to allow a different number of entries to be displayed.  The
   window size and gadget placement must also be altered.
   Feel free to improve this restriction */
#define DENTS		5L		/* 5 displayed at a time */

#define DSIZE		FCHARS+1L	/* Size of a directory entry   */
#define	DBUFSIZ		3000L		/* Number of bytes for all entries */
#define BCOL		1L		/* Background color	*/
#define FCOL		2L		/* Foreground color	*/
#define REQHEIGHT	120L
#define REQWIDTH	320L
#define FILLWIDTH	270L

#endif

