/* 	External Definitions and Calls 	*/

#include "LazyAll.h"

GLOBAL struct Window		*window;

/*
		Module name = Main
		Last Change was on 10/6/88
*/

int
main()
{
ULONG	events, waitmask;
static int	check1;

/* 
	*************************************************************
		Do the Initial Setup
		Open the Libraries and Debugs

		You Supply "Initialize()"!!!
	************************************************************* 
*/

	Initialize();

/*
	*************************************************************
		Do the Wait for Messages Bit
	************************************************************* 
*/

	check1 = TRUE;	/*	Check for Intuition events */
	waitmask = (1 << window->UserPort->mp_SigBit);

	{ while ( check1 ) {
		events = Wait(waitmask);

		{ if ( events & INT_IN ) {
			/* You supply "Intuition_Handler()"!!!! */
			check1 = Intuition_Handler();
		; } }
	; } }

/* ************************************************************* */
/* **************	  Close what was opened	  **************** */
/* ************************************************************* */

	/* You supply "Close()"!!!! */
	Close();
}
