/* settime.rexx  */
/* If you have AREXX and WShell you can insert this in your */
/* startup sequence.  Will run AtomClock just once a month and */
/* set the hardware clock */

paramstr = 'z/EDT'  /* set command line arguments for AtomClock */

'DATE >RAM:LastSet.dat'
NewMonth = GetMonth('RAM:LastSet.dat');
IF EXISTS('S:LastSet.dat') THEN
     OldMonth = GetMonth('S:LastSet.dat')
   ELSE
     OldMonth = 'Nul'  /* arbitrary - to make unequal */  
'DELETE RAM:LastSet.dat'
IF OldMonth ~= NewMonth THEN
   DO
     'AtomClock' paramstr
     IF rc = 0 THEN 
     DO
      'COPY RAM:LastSet.dat S:'
      /* change this for your hardware clock if necessary */
      'SETCLOCK OPT SAVE'  
   END
EXIT

GetMonth:
arg filename
   CALL OPEN('datefile',filename,'R');
   datestr = READLN('datefile');
   CALL CLOSE('datefile')
   PARSE VAR datestr WeekDay DD '-' Mon '-' YR Time
   RETURN Mon
