/*   Image g11_image  
          Width:    16
         Height:   8
          Depth:    5
     TransColor:    6  */

/* Image Data */
UWORD g11_imageData[] =
{
    0x0,
    0x80,
    0x180,
    0x80,
    0x80,
    0x80,
    0x3E0,
    0x0,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0x0,
    0x80,
    0x180,
    0x80,
    0x80,
    0x80,
    0x3E0,
    0x0,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF
 };

struct Image g11_image =
{
	0,0,			/* LeftEdge, TopEdge  */
	16,8,5,		/* Width, Height, Depth */
	&g11_imageData[0],		/* Pointer to Image data */
	31,0,			/* PlanePick, PlaneOnOff */
	NULL,			/* NextImage pointer */
};



/*   Image g11b_image  
          Width:    16
         Height:   8
          Depth:    5
     TransColor:    6  */

UWORD g11b_imageData[] =
{
/* Raster width is 1 words*/
/* Plane 0 raster image */
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0x0,
    0x80,
    0x180,
    0x80,
    0x80,
    0x80,
    0x3E0,
    0x0,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0xFFFF,
    0x0,
    0x80,
    0x180,
    0x80,
    0x80,
    0x80,
    0x3E0,
    0x0,
    0x0,
    0x80,
    0x180,
    0x80,
    0x80,
    0x80,
    0x3E0,
    0x0
 };

struct Image g11b_image =
{
	0,0,			/* LeftEdge, TopEdge  */
	16,8,5,		/* Width, Height, Depth */
	&g11b_imageData[0],		/* Pointer to Image data */
	31,0,			/* PlanePick, PlaneOnOff */
	NULL,			/* NextImage pointer */
};
/*   Image g12_image  
          Width:    18
         Height:   8
          Depth:    5
     TransColor:    6  */

UWORD g12_imageData[] =
{
/* Raster width is 2 words*/
    0x0,0x0,
    0x3E0,0x0,
    0x20,0x0,
    0xE0,0x0,
    0x380,0x0,
    0x200,0x0,
    0x3E0,0x0,
    0x0,0x0,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0x0,0x0,
    0x3E0,0x0,
    0x20,0x0,
    0xE0,0x0,
    0x380,0x0,
    0x200,0x0,
    0x3E0,0x0,
    0x0,0x0,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000
  };

struct Image g12_image =
{
	0,0,			/* LeftEdge, TopEdge  */
	18,8,5,		/* Width, Height, Depth */
	&g12_imageData[0],		/* Pointer to Image data */
	31,0,			/* PlanePick, PlaneOnOff */
	NULL,			/* NextImage pointer */
};
/*   Image g12b_image  
          Width:    18
         Height:   8
          Depth:    5
     TransColor:    6  */

UWORD g12b_imageData[] =
{
/* Raster width is 2 words*/
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0x0,0x3FFF,
    0x3E0,0x3FFF,
    0x20,0x3FFF,
    0xE0,0x3FFF,
    0x380,0x3FFF,
    0x200,0x3FFF,
    0x3E0,0x3FFF,
    0x0,0x3FFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0x0,0x0,
    0x3E0,0x0,
    0x20,0x0,
    0xE0,0x0,
    0x380,0x0,
    0x200,0x0,
    0x3E0,0x0,
    0x0,0x0,
    0x0,0x0,
    0x3E0,0x0,
    0x20,0x0,
    0xE0,0x0,
    0x380,0x0,
    0x200,0x0,
    0x3E0,0x0,
    0x0,0x0
 };

struct Image g12b_image =
{
	0,0,			/* LeftEdge, TopEdge  */
	18,8,5,		/* Width, Height, Depth */
	&g12b_imageData[0],		/* Pointer to Image data */
	31,0,			/* PlanePick, PlaneOnOff */
	NULL,			/* NextImage pointer */
};




/*   Image g13_image  
          Width:    18
         Height:   8
          Depth:    5
     TransColor:    6  */

UWORD g13_imageData[] =
{
    0x0,0x0,
    0x1F8,0x0,
    0x8,0x0,
    0x78,0x0,
    0x8,0x0,
    0x8,0x0,
    0x1F8,0x0,
    0x0,0x0,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0x0,0x0,
    0x1F8,0x0,
    0x8,0x0,
    0x78,0x0,
    0x8,0x0,
    0x8,0x0,
    0x1F8,0x0,
    0x0,0x0,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000

};

struct Image g13_image =
{
	0,0,			/* LeftEdge, TopEdge  */
	18,8,5,		/* Width, Height, Depth */
	&g13_imageData[0],		/* Pointer to Image data */
	31,0,			/* PlanePick, PlaneOnOff */
	NULL,			/* NextImage pointer */
};




/*   Image g13b_image  
          Width:    18
         Height:   8
          Depth:    5
     TransColor:    6  */

UWORD g13b_imageData[] =
{
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0x0,0x3FFF,
    0x1F8,0x3FFF,
    0x8,0x3FFF,
    0x78,0x3FFF,
    0x8,0x3FFF,
    0x8,0x3FFF,
    0x1F8,0x3FFF,
    0x0,0x3FFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0x0,0x0,
    0x1F8,0x0,
    0x8,0x0,
    0x78,0x0,
    0x8,0x0,
    0x8,0x0,
    0x1F8,0x0,
    0x0,0x0,
    0x0,0x0,
    0x1F8,0x0,
    0x8,0x0,
    0x78,0x0,
    0x8,0x0,
    0x8,0x0,
    0x1F8,0x0,
    0x0,0x0
};

struct Image g13b_image =
{
	0,0,			/* LeftEdge, TopEdge  */
	18,8,5,		/* Width, Height, Depth */
	&g13b_imageData[0],		/* Pointer to Image data */
	31,0,			/* PlanePick, PlaneOnOff */
	NULL,			/* NextImage pointer */
};


/*   Image g14_image  
          Width:    18
         Height:   8
          Depth:    5
     TransColor:    6  */

UWORD g14_imageData[] =
{
    0x0,0x0,
    0x640,0x0,
    0x640,0x0,
    0x640,0x0,
    0x7F0,0x0,
    0x40,0x0,
    0x40,0x0,
    0x0,0x0,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0x0,0x0,
    0x640,0x0,
    0x640,0x0,
    0x640,0x0,
    0x7F0,0x0,
    0x40,0x0,
    0x40,0x0,
    0x0,0x0,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000
 };

struct Image g14_image =
{
	0,0,			/* LeftEdge, TopEdge  */
	18,8,5,		/* Width, Height, Depth */
	&g14_imageData[0],		/* Pointer to Image data */
	31,0,			/* PlanePick, PlaneOnOff */
	NULL,			/* NextImage pointer */
};



/*   Image g14b_image  
          Width:    18
         Height:   8
          Depth:    5
     TransColor:    6  */


UWORD g14b_imageData[] =
{

    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0xFFFF,0xC000,
    0x0,0x3FFF,
    0x640,0x3FFF,
    0x640,0x3FFF,
    0x640,0x3FFF,
    0x7F0,0x3FFF,
    0x40,0x3FFF,
    0x40,0x3FFF,
    0x0,0x3FFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,
    0x0,0x0,
    0x640,0x0,
    0x640,0x0,
    0x640,0x0,
    0x7F0,0x0,
    0x40,0x0,
    0x40,0x0,
    0x0,0x0,
    0x0,0x0,
    0x640,0x0,
    0x640,0x0,
    0x640,0x0,
    0x7F0,0x0,
    0x40,0x0,
    0x40,0x0,
    0x0,0x0
  };

struct Image g14b_image =
{
	0,0,			/* LeftEdge, TopEdge  */
	18,8,5,		/* Width, Height, Depth */
	&g14b_imageData[0],		/* Pointer to Image data */
	31,0,			/* PlanePick, PlaneOnOff */
	NULL,			/* NextImage pointer */
};


/*   HERE!  */
/*   Image done_image  
          Width:    15
         Height:   43
          Depth:    5
     TransColor:    0  */
/* Current color register assignments for this picture are:
 0 -> R: 0 G: 0 B: 0       1 -> R:14 G:12 B:10      
 2 -> Not Used             3 -> Not Used            
 4 -> Not Used             5 -> Not Used            
 6 -> Not Used             7 -> Not Used            
 8 -> Not Used             9 -> Not Used            
10 -> Not Used            11 -> Not Used            
12 -> Not Used            13 -> Not Used            
14 -> Not Used            15 -> Not Used            
16 -> Not Used            17 -> Not Used            
18 -> R: 1 G: 7 B: 3      19 -> Not Used            
20 -> R: 3 G: 3 B: 3      21 -> Not Used            
22 -> Not Used            23 -> Not Used            
24 -> Not Used            25 -> Not Used            
26 -> Not Used            27 -> Not Used            
28 -> Not Used            29 -> Not Used            
30 -> Not Used            31 -> Not Used            
*/

/* Image Data */

UWORD done_imageData[] =
{
/* Bit Plane #0 */

   0x0000,
   0x0000,
   0x0000,
   0x0f80,
   0x06c0,
   0x0660,
   0x0660,
   0x0660,
   0x06c0,
   0x0f80,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x03c0,
   0x0660,
   0x0660,
   0x0660,
   0x03c0,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x07c0,
   0x0660,
   0x0660,
   0x0660,
   0x0660,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x03c0,
   0x0660,
   0x07e0,
   0x0600,
   0x03c0,
   0x0000,
   0x0000,
   0x0000,

/* Bit Plane #1 */

   0x0000,
   0x7ffc,
   0x7ffc,
   0x707c,
   0x793c,
   0x799c,
   0x799c,
   0x799c,
   0x793c,
   0x707c,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7c3c,
   0x799c,
   0x799c,
   0x799c,
   0x7c3c,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x783c,
   0x799c,
   0x799c,
   0x799c,
   0x799c,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7c3c,
   0x799c,
   0x781c,
   0x79fc,
   0x7c3c,
   0x7ffc,
   0x7ffc,
   0x0000,

/* Bit Plane #2 */

   0xfffe,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0xfffe,

/* Bit Plane #3 */

   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,

/* Bit Plane #4 */

   0xfffe,
   0xfffe,
   0xfffe,
   0xf07e,
   0xf93e,
   0xf99e,
   0xf99e,
   0xf99e,
   0xf93e,
   0xf07e,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfc3e,
   0xf99e,
   0xf99e,
   0xf99e,
   0xfc3e,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfffe,
   0xf83e,
   0xf99e,
   0xf99e,
   0xf99e,
   0xf99e,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfc3e,
   0xf99e,
   0xf81e,
   0xf9fe,
   0xfc3e,
   0xfffe,
   0xfffe,
   0xfffe
};
struct Image done_image =
{
	0,0,			/* LeftEdge, TopEdge  */
	15,43,5,		/* Width, Height, Depth */
	&done_imageData[0],		/* Pointer to Image data */
	31,0,			/* PlanePick, PlaneOnOff */
	NULL,			/* NextImage pointer */
};

/*   HERE2   */
/*   Image doneb_image  
          Width:    15
         Height:   43
          Depth:    5
     TransColor:    0  */
/* Current color register assignments for this picture are:
 0 -> R: 0 G: 0 B: 0       1 -> R:14 G:12 B:10      
 2 -> Not Used             3 -> Not Used            
 4 -> Not Used             5 -> R: 1 G: 2 B: 5      
 6 -> Not Used             7 -> Not Used            
 8 -> Not Used             9 -> Not Used            
10 -> Not Used            11 -> Not Used            
12 -> Not Used            13 -> Not Used            
14 -> Not Used            15 -> Not Used            
16 -> Not Used            17 -> Not Used            
18 -> Not Used            19 -> Not Used            
20 -> R: 3 G: 3 B: 3      21 -> Not Used            
22 -> Not Used            23 -> Not Used            
24 -> Not Used            25 -> Not Used            
26 -> Not Used            27 -> Not Used            
28 -> Not Used            29 -> Not Used            
30 -> Not Used            31 -> Not Used            
*/

/* Image Data */

UWORD doneb_imageData[] =
{
/* Bit Plane #0 */

   0x0000,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x0000,

/* Bit Plane #1 */

   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,

/* Bit Plane #2 */

   0xfffe,
   0xfffe,
   0xfffe,
   0xf07e,
   0xf93e,
   0xf99e,
   0xf99e,
   0xf99e,
   0xf93e,
   0xf07e,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfc3e,
   0xf99e,
   0xf99e,
   0xf99e,
   0xfc3e,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfffe,
   0xf83e,
   0xf99e,
   0xf99e,
   0xf99e,
   0xf99e,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfffe,
   0xfc3e,
   0xf99e,
   0xf81e,
   0xf9fe,
   0xfc3e,
   0xfffe,
   0xfffe,
   0xfffe,

/* Bit Plane #3 */

   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,

/* Bit Plane #4 */

   0xfffe,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0xfffe
};
struct Image doneb_image =
{
	0,0,			/* LeftEdge, TopEdge  */
	15,43,5,		/* Width, Height, Depth */
	&doneb_imageData[0],		/* Pointer to Image data */
	31,0,			/* PlanePick, PlaneOnOff */
	NULL,			/* NextImage pointer */
};


/*   Image starta_image  
          Width:    15
         Height:   54
          Depth:    5
     TransColor:    0  */
/* Current color register assignments for this picture are:
 0 -> R: 0 G: 0 B: 0       1 -> Not Used            
 2 -> Not Used             3 -> R:15 G:15 B:13      
 4 -> Not Used             5 -> Not Used            
 6 -> Not Used             7 -> Not Used            
 8 -> R: 0 G:14 B: 0       9 -> Not Used            
10 -> Not Used            11 -> Not Used            
12 -> Not Used            13 -> Not Used            
14 -> Not Used            15 -> R: 2 G: 2 B: 2      
16 -> Not Used            17 -> Not Used            
18 -> Not Used            19 -> Not Used            
20 -> R: 3 G: 3 B: 3      21 -> Not Used            
22 -> Not Used            23 -> Not Used            
24 -> Not Used            25 -> Not Used            
26 -> Not Used            27 -> Not Used            
28 -> Not Used            29 -> Not Used            
30 -> Not Used            31 -> Not Used            
*/

/* Image Data */

UWORD starta_imageData[] =
{
/* Bit Plane #0 */

   0x0000,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7cfc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x0000,

/* Bit Plane #1 */

   0x0000,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7cfc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x0000,

/* Bit Plane #2 */

   0xfffe,
   0x8002,
   0x8002,
   0x8782,
   0x8cc2,
   0x8e02,
   0x8702,
   0x81c2,
   0x8cc2,
   0x8782,
   0x8002,
   0x8002,
   0x8102,
   0x8302,
   0x87c2,
   0x8302,
   0x8302,
   0x8342,
   0x8182,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8782,
   0x80c2,
   0x83c2,
   0x8cc2,
   0x8762,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8ec2,
   0x8762,
   0x8662,
   0x8602,
   0x8f02,
   0x8002,
   0x8002,
   0x8002,
   0x8102,
   0x8302,
   0x87c2,
   0x8302,
   0x8302,
   0x8342,
   0x8182,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0xfffe,

/* Bit Plane #3 */

   0x0000,
   0x0000,
   0x0000,
   0x0780,
   0x0cc0,
   0x0e00,
   0x0700,
   0x01c0,
   0x0cc0,
   0x0780,
   0x0000,
   0x0000,
   0x0100,
   0x0300,
   0x07c0,
   0x0300,
   0x0300,
   0x0340,
   0x0180,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0780,
   0x00c0,
   0x03c0,
   0x0fc0,
   0x0760,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0ec0,
   0x0760,
   0x0660,
   0x0600,
   0x0f00,
   0x0000,
   0x0000,
   0x0000,
   0x0100,
   0x0300,
   0x07c0,
   0x0300,
   0x0300,
   0x0340,
   0x0180,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,

/* Bit Plane #4 */

   0xfffe,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0xfffe
};
struct Image starta_image =
{
	0,0,			/* LeftEdge, TopEdge  */
	15,54,5,		/* Width, Height, Depth */
	&starta_imageData[0],		/* Pointer to Image data */
	31,0,			/* PlanePick, PlaneOnOff */
	NULL,			/* NextImage pointer */
};
/*   Image startb_image  
          Width:    15
         Height:   54
          Depth:    5
     TransColor:    0  */
/* Current color register assignments for this picture are:
 0 -> R: 0 G: 0 B: 0       1 -> Not Used            
 2 -> Not Used             3 -> Not Used            
 4 -> Not Used             5 -> Not Used            
 6 -> Not Used             7 -> Not Used            
 8 -> R: 0 G:14 B: 0       9 -> Not Used            
10 -> Not Used            11 -> Not Used            
12 -> Not Used            13 -> Not Used            
14 -> Not Used            15 -> R: 2 G: 2 B: 2      
16 -> Not Used            17 -> Not Used            
18 -> Not Used            19 -> Not Used            
20 -> R: 3 G: 3 B: 3      21 -> Not Used            
22 -> Not Used            23 -> Not Used            
24 -> Not Used            25 -> Not Used            
26 -> Not Used            27 -> Not Used            
28 -> Not Used            29 -> Not Used            
30 -> Not Used            31 -> Not Used            
*/

/* Image Data */

UWORD startb_imageData[] =
{
/* Bit Plane #0 */

   0x0000,
   0x0000,
   0x0000,
   0x0780,
   0x0cc0,
   0x0e00,
   0x0700,
   0x01c0,
   0x0cc0,
   0x0780,
   0x0000,
   0x0000,
   0x0100,
   0x0300,
   0x07c0,
   0x0300,
   0x0300,
   0x0340,
   0x0180,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0780,
   0x00c0,
   0x03c0,
   0x0cc0,
   0x0760,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0ec0,
   0x0760,
   0x0660,
   0x0600,
   0x0f00,
   0x0000,
   0x0000,
   0x0000,
   0x0100,
   0x0300,
   0x07c0,
   0x0300,
   0x0300,
   0x0340,
   0x0180,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,

/* Bit Plane #1 */

   0x0000,
   0x0000,
   0x0000,
   0x0780,
   0x0cc0,
   0x0e00,
   0x0700,
   0x01c0,
   0x0cc0,
   0x0780,
   0x0000,
   0x0000,
   0x0100,
   0x0300,
   0x07c0,
   0x0300,
   0x0300,
   0x0340,
   0x0180,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0780,
   0x00c0,
   0x03c0,
   0x0cc0,
   0x0760,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0ec0,
   0x0760,
   0x0660,
   0x0600,
   0x0f00,
   0x0000,
   0x0000,
   0x0000,
   0x0100,
   0x0300,
   0x07c0,
   0x0300,
   0x0300,
   0x0340,
   0x0180,
   0x0000,
   0x0000,
   0x0000,
   0x0000,
   0x0000,

/* Bit Plane #2 */

   0xfffe,
   0x8002,
   0x8002,
   0x8782,
   0x8cc2,
   0x8e02,
   0x8702,
   0x81c2,
   0x8cc2,
   0x8782,
   0x8002,
   0x8002,
   0x8102,
   0x8302,
   0x87c2,
   0x8302,
   0x8302,
   0x8342,
   0x8182,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8782,
   0x80c2,
   0x83c2,
   0x8cc2,
   0x8762,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8ec2,
   0x8762,
   0x8662,
   0x8602,
   0x8f02,
   0x8002,
   0x8002,
   0x8002,
   0x8102,
   0x8302,
   0x87c2,
   0x8302,
   0x8302,
   0x8342,
   0x8182,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0xfffe,

/* Bit Plane #3 */

   0x0000,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x7ffc,
   0x0000,

/* Bit Plane #4 */

   0xfffe,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0x8002,
   0xfffe
};

struct Image startb_image =
{
	0,0,			/* LeftEdge, TopEdge  */
	15,54,5,		/* Width, Height, Depth */
	&startb_imageData[0],		/* Pointer to Image data */
	31,0,			/* PlanePick, PlaneOnOff */
	NULL,			/* NextImage pointer */
};
