#include <exec/types.h>
#include <exec/ports.h>
#include <exec/memory.h>
#include <exec/devices.h>
#include <exec/execbase.h>
#include <exec/interrupts.h>
#include <graphics/gfxbase.h>
#include <intuition/intuition.h>
#include <intuition/intuitionbase.h>
#include <libraries/dos.h>
#include <libraries/dosextens.h>
#include <devices/conunit.h>
#include <devices/keymap.h>
#include <devices/input.h>
#include <devices/inputevent.h>

struct ConsoleBase {
	struct Device conDevice;
	char reserved[26];
	struct List conUnits;
};

#include <functions.h>

/* mouse states */
#define M_UP	0
#define M_MOVE	1
#define M_DOWN	2

/* 'snip' container defines */
#define CON_SNIP	1
#define WIN_SNIP	2

#define PRE_SIZE	32


