#include <stdio.h>
#include <functions.h>

#define FALSE      (0)
#define TRUE       (-1)

#ifdef DEBUG
char *libs[] =
{
   "intuition.library",
   "graphics.library",
   NULL
};

void *IntuitionBase = NULL;
void *GfxBase = NULL;
unsigned long endBases = NULL;
#endif

int openLibs(names,bases)
char **names; void **bases;
{
   int rval = TRUE;

   while (*names)
   {
       *bases = (void *)OpenLibrary(*(names++),0L);
       if (!(*(bases++))) {rval = FALSE; break;}
   }
   return(rval);
}

int closeLibs(bases)
void **bases;
{
   while (*bases)
   {
       CloseLibrary(*(bases++));
   }
}

#ifdef DEBUG
main()
{
   int result;

   result = openLibs(libs,&IntuitionBase);
   printf("IntuitionBase = %lx\nGfxBase = %lx\n",IntuitionBase,GfxBase);
   closeLibs(&IntuitionBase);
   exit(result);
}
#endif
